#!/bin/bash

file="lazer.wav"

getkbds()
{
	xinput list | grep -i keyboard | grep -vi virtual | sed 's/.*id=//' | cut -f1
}

getevents()
{
	while :; do
		xinput test "$1"
		sleep 1
	done
}

playsound()
{
	echo $1
}

curtime()
{
	date +%s%3N | tail -c 8
}

nextpress=0
keypressed()
{
	if [ $(curtime) -gt "$nextpress" ]; then
		playsound $(sed 's/key press\s*//' <<< "$1") &
		nextpress=$(expr $(curtime) '+' '50')
	fi
}

synther()
{
	getevents "$1" \
		| grep --line-buffered -i "key press" \
		| while read -r line; do keypressed "$line"; done
}

for i in $(getkbds); do
	synther "$i" &
done

onterm()
{
	pkill -TERM -P $$
	exit $1
	echo "exit" >> sock
	rm sock
}

trap onterm SIGINT
trap onterm SIGTERM

while :; do sleep 1; done
